from random import randint
import mmaze
import sys


def main():
    print()

    if len(sys.argv) != 4:
        print("Usage: python gerador.py [width] [height] -hddl or -pddl\n")
        return -1

    try:
        w = int(sys.argv[1])
        h = int(sys.argv[2])
    except:
        print("Invalid dimensions")
        print("Usage: python gerador.py [width] [height] -hddl or -pddl\n")
        return -2

    if sys.argv[3] not in ("-hddl",  "-pddl"):
        print(f"Invalid problem type \"{sys.argv[3]}\"")
        print("Usage: python gerador.py [width] [height] -hddl or -pddl\n")
        return -2

    m = mmaze.generate(width=int(w/2) + 1, height=int(h/2) + 1)
    m = m.tostring().splitlines()
    maze = list()

    idx = 0
    for i in range(1, len(m) - 1):
        maze.append(list())
        for j in range(2, len(m[i]) - 3, 2):
            maze[idx].append(m[i][j])
        idx += 1

    t = randint(0, w)
    b = randint(0, int(h / 3))
    p = randint(0, 2)
    pb = open(f"_pb{w}-{h}-{t}-{b}.{sys.argv[3][1:]}", "w")

    pb.write(f'''(define (problem pb{w}-{h}-{t}-{b})
  (:domain labirinto)\n
  (:objects\n''')

    for i in range(h):
        pb.write('\t')
        for j in range(w):
            pb.write(f"p{i}-{j} ")
        pb.write('\n')
    pb.write("  )\n\n  (:init\n")

    saida = (-1, -1)
    for i in range(h):
        for j in range(w):
            if maze[i][j] != '|':
                pb.write(f"\t(livre p{i}-{j})\n")
            else:
                maze[i][j] = '#'

    while True:
        x = randint(0, w - 1)
        y = randint(0, h - 1)
        if maze[y][x] != '#':
            pb.write(f"\t(em p{y}-{x})\n")
            maze[y][x] = 'S'
            break

    while True:
        x = randint(0, w - 1)
        y = randint(0, h - 1)
        if maze[y][x] not in ('#', 'S'):
            pb.write(f"\t(saida p{y}-{x})\n")
            maze[y][x] = 'E'
            saida = (y, x)
            break

    for i in range(t):
        while True:
            x = randint(0, w - 1)
            y = randint(0, h - 1)
            if maze[y][x] not in ('#', 'T'):
                pb.write(f"\t(tesouro p{y}-{x})\n")
                maze[y][x] = 'T'
                break

    for i in range(b):
        while True:
            x = randint(0, w - 1)
            y = randint(0, h - 1)
            if maze[y][x] not in ('#', 'T', 'B'):
                pb.write(f"\t(buraco p{y}-{x})\n")
                maze[y][x] = 'B'
                break

    for i in range(b):
        while True:
            x = randint(0, w - 1)
            y = randint(0, h - 1)
            if maze[y][x] not in ('#', 'T', 'B', 'M'):
                pb.write(f"\t(madeira p{y}-{x})\n")
                maze[y][x] = 'M'
                break

    for i in range(p):
        while True:
            x = randint(0, w - 1)
            y = randint(0, h - 1)
            if maze[y][x] not in ('#', 'T', 'B', 'M', 'P'):
                pb.write(f"\t(picareta p{y}-{x})\n")
                maze[y][x] = 'P'
                break

    dirs = (-1, 0, 1, 0, -1)
    for i in range(h):
        for j in range(w):
            for k in range(4):
                x = j + dirs[k]
                y = i + dirs[k + 1]
                if 0 <= x < w and 0 <= y < h:
                    pb.write(f"\t(adjacente p{i}-{j} p{y}-{x})\n")
    pb.write("  )\n\n")

    if sys.argv[3] == "-pddl":
        pb.write(f"  (:goal (and (em p{saida[0]}-{saida[1]}) (forall (?p) (not (tesouro ?p)))))\n)")
    else:
        pb.write("  (:htn :subtasks (sair))\n)")

    pb.close()


if __name__ == "__main__":
    main()
