(define (domain labirinto)
  (:requirements :strips :negative-preconditions)

  (:predicates
    (em ?p)
    (saida ?p)
    (livre ?p)
    (buraco ?p)
    (adjacente ?p1 ?p2)
    (tesouro ?p)
    (madeira ?p)
    (picareta ?p)
    (tem-madeira)
    (tem-picareta)
  )

  (:action andar
    :parameters (?p1 ?p2)
    :precondition (and
      (em ?p1)
      (adjacente ?p1 ?p2)
      (livre ?p2)
      (not (buraco ?p2))
    )
    :effect (and
      (not (em ?p1))
      (em ?p2)
    )
  )

  (:action pegar-tesouro
    :parameters (?p)
    :precondition (and
      (em ?p)
      (tesouro ?p)
    )
    :effect (not (tesouro ?p))
  )

  (:action pegar-madeira
    :parameters (?p)
    :precondition (and
      (not (tem-madeira))
      (em ?p)
      (madeira ?p)
    )
    :effect (and
      (tem-madeira)
      (not (madeira ?p))
    )
  )

  (:action pegar-picareta
    :parameters (?p)
    :precondition (and
      (not (tem-picareta))
      (em ?p)
      (picareta ?p)
    )
    :effect (and
      (tem-picareta)
      (not (picareta ?p))
    )
  )

  (:action tapar-buraco
    :parameters (?p1 ?p2)
    :precondition (and
      (em ?p1)
      (adjacente ?p1 ?p2)
      (buraco ?p2)
      (tem-madeira)
    )
    :effect (and
      (not (buraco ?p2))
      (not (tem-madeira))
    )
  )

  (:action destruir-parede
    :parameters (?p1 ?p2)
    :precondition (and
      (em ?p1)
      (not (livre ?p2))
      (adjacente ?p1 ?p2)
      (tem-picareta)
    )
    :effect (livre ?p2)
  )
)